/****************************************************************
*                                                               *
*    Name: MultiRenameTool.cpp                                  *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*       This file describe things that need for rename multiple *
*       files. The dialog and algorythms                        *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "MultiRename.h"
#include "Main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TMultiRenameTool *MultiRenameTool;
//---------------------------------------------------------------------------
__fastcall TMultiRenameTool::TMultiRenameTool(TComponent* Owner)
    : TForm(Owner)
{
    num=0;
    onames=NULL;
    nnames=NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMultiRenameTool::FormShow(TObject *Sender)
{
    status=0;
    Ok->Height=Ok->Font->Height+10;
    Cancel->Height=Ok->Height;
    NewNames->Width=300;
    NameFormat->Width=NewNames->Width;
    NameFormat->Top=0;
    NewNames->Top=NameFormat->Height+Form1->osztas;
    NewNames->Height=489;
    NameFormat->Left=0;
    NewNames->Left=0;

    Label2->Top=0;
    Label3->Top=Label2->Top+Label2->Height+Form1->osztas;
    Label6->Top=Label3->Top+Label3->Height+Form1->osztas;
    Label4->Top=Label6->Top+Label6->Height+Form1->osztas;
    Label7->Top=Label4->Top+Label4->Height+Form1->osztas;
    Label8->Top=Label7->Top+Label7->Height+Form1->osztas;
    Label9->Top=Label8->Top+Label8->Height+Form1->osztas;
    Label10->Top=Label9->Top+Label9->Height+Form1->osztas;
    Label11->Top=Label10->Top+Label10->Height+Form1->osztas;
    Label12->Top=Label11->Top+Label11->Height+Form1->osztas;
    Label13->Top=Label12->Top+Label12->Height+Form1->osztas;
    Label14->Top=Label13->Top+Label13->Height+Form1->osztas;
    Label15->Top=Label14->Top+Label14->Height+Form1->osztas;
    Label16->Top=Label15->Top+Label15->Height+Form1->osztas;
      Label17->Top=Label16->Top;
      Label18->Top=Label16->Top;
    Label19->Top=Label16->Top+Label16->Height+Form1->osztas;
      Label20->Top=Label19->Top;
      Label21->Top=Label19->Top;
// alja
    Label1->Top=Label19->Top+Label19->Height+Form1->osztas*3;
    Counter_width->Top=Label1->Top+Label1->Height+Form1->osztas;
    Label5->Top=Counter_width->Top+4;
    Start->Top=Counter_width->Top+Counter_width->Height+Form1->osztas;
    Starthere1->Top=Start->Top+4;
    Step->Top=Start->Top+Start->Height+Form1->osztas;
    Step1->Top=Step->Top+4;

    Height=NewNames->Top+NewNames->Height+Form1->osztas*3;
    Ok->Top=Height-Form1->osztas*3-Ok->Height;
    Cancel->Top=Ok->Top;
//    idejon a tobbi
    Label1->Left=NewNames->Width+Form1->osztas;
    Label2->Left=Label1->Left;
    Label3->Left=Label1->Left;
    Label4->Left=Label1->Left;
    Label5->Left=Label1->Left;
    Label6->Left=Label1->Left;
    Label7->Left=Label1->Left;
    Label8->Left=Label1->Left;
    Label9->Left=Label1->Left;
    Label10->Left=Label1->Left;
    Label11->Left=Label1->Left;
    Label12->Left=Label1->Left;
    Label13->Left=Label1->Left;
    Label14->Left=Label1->Left;
    Label15->Left=Label1->Left;
    Label16->Left=Label1->Left;
      Label17->Left=Label16->Left+Label16->Width+Form1->osztas*3;
      Label18->Left=Label17->Left+Label17->Width+Form1->osztas*2;
    Label19->Left=Label1->Left+Form1->osztas*2;
      Label20->Left=Label19->Left+Label19->Width+Form1->osztas*2;
      Label21->Left=Label20->Left+Label20->Width+Form1->osztas*2;
    Starthere1->Left=Label1->Left;
    Step1->Left=Label1->Left;
    Counter_width->Left=Label5->Left+Label5->Width+Form1->osztas;
    Start->Left=Counter_width->Left;
    Step->Left=Counter_width->Left;
    int nwidth=Counter_width->Left+Counter_width->Width+Form1->osztas;
    if( Label7->Left+Label7->Width+Form1->osztas>nwidth ) nwidth=Label7->Left+Label7->Width+Form1->osztas;
    if( Label14->Left+Label14->Width+Form1->osztas>nwidth ) nwidth=Label14->Left+Label14->Width+Form1->osztas;
    MultiRenameTool->Width=nwidth+Form1->osztas*3;

    Ok->Left=Width-(Form1->osztas*4+Cancel->Width+Ok->Width);
    Cancel->Left=Width-(Form1->osztas*3+Cancel->Width);

    NameFormat->Text="%FULLNAME";
    RefreshNewNames();
    NameFormat->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TMultiRenameTool::CancelClick(TObject *Sender)
{
    Close();
}
//---------------------------------------------------------------------------

AnsiString TMultiRenameTool::GetNewName(AnsiString path,AnsiString oldname,AnsiString mask,int counter,int counter_width,int time)
{
    if( oldname==".." ) return oldname;

    AnsiString ret;

    int i=1;
    while( i<=mask.Length() ) {
        if( mask[i]=='%' )
            ret=ret+Interpret(path,oldname,mask,counter,counter_width,time,i);
        else {
            ret=ret+mask[i];
            i++;
        }
    }
    return ret;
}

void TMultiRenameTool::RefreshNewNames()
{
    int here=Start->Value;

    for( int i=0;i<num;i++ ) {
        nnames[i].name=GetNewName(onames[i].path,onames[i].name,String(NameFormat->Text),here,Counter_width->Value,onames[i].date);
        here+=Step->Value;
    }

    NewNames->RowCount=num;
    NewNames->Invalidate();
}

void __fastcall TMultiRenameTool::NewNamesDrawCell(TObject *Sender,
      int ACol, int ARow, TRect &Rect, TGridDrawState State)
{
    if( ARow<num )
        NewNames->Canvas->TextRect(Rect,Rect.Left,Rect.Top,nnames[ARow].name);
//
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::OkClick(TObject *Sender)
{
    status=1;
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label2Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%NAME";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label3Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%EXT";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label6Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%FULLNAME";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label4Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%COUNTER";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::NameFormatKeyUp(TObject *Sender,
      WORD &Key, TShiftState Shift)
{
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Counter_widthChanged(TObject *Sender,
      int NewValue)
{
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::StartChanged(TObject *Sender,
      int NewValue)
{
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::StepChanged(TObject *Sender,
      int NewValue)
{
    RefreshNewNames();
}
//---------------------------------------------------------------------------

AnsiString TMultiRenameTool::Interpret(AnsiString path,AnsiString oldname,AnsiString mask,int counter,int counter_width,int time,int &i)
{
    AnsiString name=ExtractFileName(oldname);
    AnsiString ext=ExtractFileExt(oldname);
    if( ext!="" ) {
        name=name.SubString(1,name.Length()-ext.Length());
    }
    AnsiString ret;
    AnsiString what;
    bool integer=false;
    AnsiString tinteger=0;
    i++;
    while( i<=mask.Length() ) {
        if( mask[i]=='{' ) {
            i++;
            while( i<=mask.Length() && mask[i]!='}') {what=what+mask[i];i++;}
        } else what=what+mask[i];
        i++;
        if( what=="FULLNAME" ) {
            ret=ret+oldname;
            break;
        } else if( what=="NAME" ) {
            ret=ret+name;
            break;
        } else if( what=="EXT" ) {
            ret=ret+ext;
            break;
        } else if( what=="TOUP" ) {
            ret=ret+(Interpret(path,oldname,mask,counter,counter_width,time,i)).UpperCase();
            break;
        } else if( what=="TOLOW" ) {
            ret=ret+(Interpret(path,oldname,mask,counter,counter_width,time,i)).LowerCase();
            break;
        } else if( what=="STRING" ) {
            if( i<=mask.Length() && mask[i]=='{' ) {
                i++;
                while( i<=mask.Length() && mask[i]!='}') {ret=ret+mask[i];i++;}
                i++;
            }
            break;
        } else if( what=="MP3" ) {
            AnsiString which;
            AnsiString title;
            AnsiString artist;
            AnsiString album;
            AnsiString year;
            AnsiString other;
            if( i<=mask.Length() && mask[i]=='{' ) {
                i++;
                while( i<=mask.Length() && mask[i]!='}') {which=which+mask[i];i++;}
                i++;
            }
            if( which.LowerCase()=="title" ) {
                mp3id(path+oldname,title,artist,album,year,other);
                ret=ret+title;
            }
            if( which.LowerCase()=="artist") {
                mp3id(path+oldname,title,artist,album,year,other);
                ret=ret+artist;
            }
            if( which.LowerCase()=="album") {
                mp3id(path+oldname,title,artist,album,year,other);
                ret=ret+album;
            }
            if( which.LowerCase()=="year") {
                mp3id(path+oldname,title,artist,album,year,other);
                ret=ret+year;
            }
            if( which.LowerCase()=="other") {
                mp3id(path+oldname,title,artist,album,year,other);
                ret=ret+other;
            }
            break;
        } else if( what=="CONCAT" ) {
            AnsiString pre=Interpret(path,oldname,mask,counter,counter_width,time,i);
            AnsiString post=Interpret(path,oldname,mask,counter,counter_width,time,i);
            ret=ret+pre+post;
            break;
        } else if( what=="POS" ) {
            AnsiString conv=Interpret(path,oldname,mask,counter,counter_width,time,i);
            AnsiString its=Interpret(path,oldname,mask,counter,counter_width,time,i);
            ret=ret+IntToStr(conv.Pos(its));
            break;
        } else if( what=="ACCLESS" ) {
            AnsiString conv=Interpret(path,oldname,mask,counter,counter_width,time,i);
            AnsiString     acc="";
            AnsiString accless="ieauouououoaeIEAUOUOUOAE";
            for( int j=1;j<=conv.Length();j++ ) {
                int pos=acc.Pos(conv[j]);
                if( pos>0 )
                    conv[j]=accless[pos];
            }
            ret=ret+conv;
            break;
        } else if( what=="CNT" ) {
            AnsiString number=IntToStr(counter);
            AnsiString width=Interpret(path,oldname,mask,counter,counter_width,time,i);
            int iwidth=0;
            try {
                iwidth=StrToInt(width);
            } catch(...) {}
            while( number.Length()<iwidth ) number="0"+number;
                ret=ret+number;
            break;
        } else if( what=="COUNTER" ) {
            AnsiString number=IntToStr(counter);
            while( number.Length()<counter_width ) number="0"+number;
                ret=ret+number;
            break;
        } else if( what=="REPLACE" ) {
            AnsiString str=Interpret(path,oldname,mask,counter,counter_width,time,i);
            AnsiString from=Interpret(path,oldname,mask,counter,counter_width,time,i);
            AnsiString to=Interpret(path,oldname,mask,counter,counter_width,time,i);
            if( from==to ) {ret=ret+str;break;}
            while( str.Pos(from)>0 ) {
                AnsiString begin;AnsiString end;
                TForm1::AnsiSplit(str,from,begin,end);
                str=begin+to+end;
            }
            ret=ret+str;
            break;
        } else if( what=="SUBSTR" ) {
                AnsiString str=Interpret(path,oldname,mask,counter,counter_width,time,i);
                AnsiString pos1=Interpret(path,oldname,mask,counter,counter_width,time,i);
                AnsiString pos2=Interpret(path,oldname,mask,counter,counter_width,time,i);
                int ipos1=0;
                int ipos2=0;
                try {
                    ipos1=StrToInt(pos1);
                    ipos2=StrToInt(pos2);
                    ret=ret+str.SubString(ipos1,ipos2);
                } catch(...) {
                    break;
                }
            break;
        } else if( what=="yyyy" || what=="yy" ||
                   what=="mmmm" || what=="mmm" ||
                   what=="mm" || what=="m" ||
                   what=="dddd" || what=="ddd" ||
                   what=="dd" || what=="d" ||
                   what=="hh" || what=="h" ||
                   what=="nn" || what=="n" ||
                   what=="ss" || what=="s"
               ) {
            try {
                DateTimeToString(ret,what,FileDateToDateTime(time));
            } catch(...) { }
            break;
        } else {
            try {
                StrToInt(what);
                integer=true;
                tinteger=what;
                if( i>mask.Length() ) {
                    if( integer ) {
                        ret=ret+tinteger;
                        break;
                    }
                }
            } catch(...) {
                if( integer ) {
                    ret=ret+tinteger;
                    if(i<=mask.Length())i--;
                    break;
                }
            }
        }
    }
    return ret;
}

void __fastcall TMultiRenameTool::FormCreate(TObject *Sender)
{
    SetFocus();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label7Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%SUBSTR";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label8Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%TOUP";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label9Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%TOLOW";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label10Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%ACCLESS";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label11Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%STRING{}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label12Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%CNT%0";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label13Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%POS";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label14Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%REPLACE";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label15Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%CONCAT";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

int TMultiRenameTool::mp3id(AnsiString filename,AnsiString &ptitle,AnsiString &partist,AnsiString &palbum,AnsiString &pyear,AnsiString &pother)
{
	char buf[3];
	int bytesread;
	char title[31], artist[31], album[31],year[5],other[31];

    FILE *h=fopen(filename.c_str(),"r");
	if( h )
	{
		if( fseek(h, -128, SEEK_END)==0 )
		{
			if( (bytesread=fread (buf,sizeof(char), 3,h))==3 &&
				!strncmp (buf, "TAG", 3))
			{
				bytesread=fread(title,sizeof(char),30,h);
				title[30] = 0;
				bytesread=fread(artist,sizeof(char),30,h);
				artist[30] = 0;
				bytesread=fread(album,sizeof(char),30,h);
				album[30] = 0;
				bytesread=fread(year,sizeof(char),4,h);
				year[4] = 0;
				bytesread=fread(other,sizeof(char),30,h);
				other[30] = 0;
				ptitle=Trim(String (title));
				partist=Trim(String(artist));
				palbum=Trim(String(album));
				pyear=Trim(String(year));
				pother=Trim(String(other));
			}
		}
		fclose(h);
	}
    return 0;
}

void __fastcall TMultiRenameTool::Label16Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"%MP3";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label17Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"{TITLE}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label18Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"{ARTIST}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label19Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"{ALBUM}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label20Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"{YEAR}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------

void __fastcall TMultiRenameTool::Label21Click(TObject *Sender)
{
    NameFormat->Text=NameFormat->Text+"{OTHER}";
    RefreshNewNames();
}
//---------------------------------------------------------------------------


