/****************************************************************
*                                                               *
*    Name: MyThread.h                                           *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of the CMyThread class. This   *
*        will handle the parallel copy, move and delete. It is  *
*        only singletask, because of the popups.                *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MyThreadH
#define MyThreadH

#include "Main.h"
#include "MyDirent.h"

class my_file;

class CMyThread// : public TThread
{
private:
    int MoveDir(AnsiString SrcDir,AnsiString MvDirFrom,AnsiString DstDir,AnsiString MvDirTo, bool presattr, int attr);
    int MoveFileTo_my(AnsiString Src,AnsiString Dst, bool presattr, int attr,__int64 size,bool link);
    int CopyDir(AnsiString SrcDir,AnsiString CpDirFrom,AnsiString DstDir,AnsiString CpDirTo, bool presattr, int attr);
    int CopyFileTo_my(AnsiString Src,AnsiString Dst, bool presattr, int attr,__int64 size);
    int DeleteDir(AnsiString SrcDir,AnsiString DelDir);
    int DeleteFile_my(AnsiString Src);

    my_file* panel;
    int count;
    int count2;
    AnsiString dstdir;
    AnsiString srcdir;
    AnsiString whattodo;
    AnsiString mask;
    int mode;
    bool symlinks;
    bool attr;
    int copybytes;
    bool allproceed;
    bool allproceed_err;
    bool allproceed_app;
    TProgressForm *progform;

    int todo();
    int ChmodFile_my(AnsiString path, int stat);
    AnsiString GetStringByMask(AnsiString string, AnsiString mask);
    bool CopyFileTo_Base(AnsiString Src,AnsiString Dst,__int64 size);

public:
    bool created;
    CMyThread(bool CreateSuspend)// : TThread(CreateSuspend)
    {
//        Priority=tpIdle;
        created=false;
    }

    ~CMyThread() {
        if( panel ) {
            delete []panel;
            panel=NULL;
        }
    }

    void __fastcall Execute() {
        if( !created ) return;
        todo();
        created=false;
    }

    int Copy_my();
    int Move_my();
    int Delete_my();

    int Create(TComponent* Owner,my_file* ppanel,int pcount,int pcount2,AnsiString pwhattodo,AnsiString psrcdir,AnsiString pdstdir,AnsiString pmask,int pmode,bool psymlink,bool pattr,int pcopybytes);
    int Destroy() {created=false;}

};
//---------------------------------------------------------------------------
#endif
