/****************************************************************
*                                                               *
*    Name: NewShortCut.cpp                                      *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the cpp file of the newshortcut form.          *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "NewShortCut.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TNewShortCutForm *NewShortCutForm;
//---------------------------------------------------------------------------
__fastcall TNewShortCutForm::TNewShortCutForm(TComponent* Owner)
    : TForm(Owner)
{
    shortcut=-1;
}
//---------------------------------------------------------------------------
void __fastcall TNewShortCutForm::FormShow(TObject *Sender)
{
    shortcut=-1;
}
//---------------------------------------------------------------------------

void __fastcall TNewShortCutForm::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
// shift, ctrl, shift+alt, alt
    if( Key==4128 || Key==4129 || Key==4130 || Key==4131 ) return;
// esc, space, enter, tab, up, down, pageup, pagedown, home, end
    if( Key==4096
//        || Key==32 || Key==4100 || Key==4097
//        || Key==4115 || Key==4117 || Key==4118 || Key==4119
//        || Key==4112 || Key==4113
         ) {
        shortcut=-1;
        TForm::Close();
        return;
    }
    shortcut=ShortCut(Key,Shift);
    TForm::Close();
}
//---------------------------------------------------------------------------

void __fastcall TNewShortCutForm::FormCreate(TObject *Sender)
{
    SetFocus();    
}
//---------------------------------------------------------------------------

