/****************************************************************
*                                                               *
*    Name: Progress.h                                           *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of progressform. This show a   *
*        form, if a procedure take a long time, like copy,      *
*        delete or find a file etc.                             *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef ProgressH
#define ProgressH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QComCtrls.hpp>
#include <QFileCtrls.hpp>
#include "MyDirent.h"
//---------------------------------------------------------------------------
class TProgressForm : public TForm
{
__published:	// IDE-managed Components
    TProgressBar *ProgressBar1;
    TProgressBar *ProgressBar2;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TProgressBar *ProgressBar3;
    TLabel *speed;
    TButton *Cancel;
    void __fastcall yesbClick(TObject *Sender);
    void __fastcall nobClick(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall CancelClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall CancelKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
public:		// User declarations
    CMyDirent *dirent;
    bool hangon;
    int button;
    bool cancel;
    __fastcall TProgressForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TProgressForm *ProgressForm;
//---------------------------------------------------------------------------
#endif
