//---------------------------------------------------------------------------
#include <clx.h>
#pragma hdrstop
USEFORM("Main.cpp", Form1);
USEFORM("Action.cpp", ActionForm);
USEFORM("Viewer.cpp", ViewForm);
USEFORM("Progress.cpp", ProgressForm);
USEFORM("Configure.cpp", ConfigForm);
USEFORM("NewShortCut.cpp", NewShortCutForm);
USEFORM("MultiRename.cpp", MultiRenameTool);
USEFORM("InformationForm.cpp", InfoForm);
//---------------------------------------------------------------------------
int main(void)
{
    try
    {
        Application->Initialize();
        Application->CreateForm(__classid(TForm1), &Form1);
         Application->CreateForm(__classid(TActionForm), &ActionForm);
         Application->CreateForm(__classid(TViewForm), &ViewForm);
         Application->CreateForm(__classid(TProgressForm), &ProgressForm);
         Application->CreateForm(__classid(TConfigForm), &ConfigForm);
         Application->CreateForm(__classid(TNewShortCutForm), &NewShortCutForm);
         Application->CreateForm(__classid(TMultiRenameTool), &MultiRenameTool);
         Application->CreateForm(__classid(TInfoForm), &InfoForm);
         Application->Run();
    }
    catch (Exception &exception)
    {
        Application->ShowException(&exception);
    }
    catch(...)
    {
        try
        {
            throw Exception("");
        }
        catch(Exception &exception)
        {
            Application->ShowException(&exception);
        }
    }
    return 0;
}
//---------------------------------------------------------------------------
