/****************************************************************
*                                                               *
*    Name: Configure.h                                          *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of the configuration form.     *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef ConfigureH
#define ConfigureH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QComCtrls.hpp>
#include "NewShortCut.h"
#include <QDialogs.hpp>
#include <QGrids.hpp>
//---------------------------------------------------------------------------
class MySC
{
public:
    AnsiString what;
    unsigned short *sc;
};
class TConfigForm : public TForm
{
__published:	// IDE-managed Components
    TButton *Save;
    TButton *Close;
    TPageControl *PageControl1;
    TTabSheet *TabSheet1;
    TLabel *Label1;
    TEdit *execpath;
    TLabel *Label2;
    TTabSheet *TabSheet2;
    TLabel *Label3;
    TLabel *Label4;
    TSpinEdit *colwidth1;
    TSpinEdit *colwidth2;
    TSpinEdit *colwidth3;
    TSpinEdit *colwidth4;
    TSpinEdit *colwidth5;
    TLabel *Label5;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TLabel *Label13;
    TLabel *Label14;
    TComboBox *colwhat1;
    TComboBox *colwhat3;
    TComboBox *colwhat4;
    TComboBox *colwhat5;
    TComboBox *colwhat2;
    TLabel *Label15;
    TEdit *packageprefix;
    TLabel *Label16;
    TLabel *Label17;
    TEdit *tmppath;
    TLabel *Label18;
    TEdit *execcompare;
    TLabel *Label19;
    TLabel *Label20;
    TEdit *exteditor;
    TLabel *Label21;
    TLabel *Label22;
    TEdit *dateformat;
    TLabel *Label23;
    TLabel *Label24;
    TCheckBox *showhiddenfiles;
    TCheckBox *ignorecase;
    TCheckBox *humanread;
    TLabel *Label30;
    TSpinEdit *copybytes;
    TLabel *Label31;
    TSpinEdit *maxthreads;
    TLabel *Label32;
    TSpinEdit *fontheight;
    TSpinEdit *fontweight;
    TLabel *Label33;
    TLabel *Label34;
    TSpinEdit *viewerfontheight;
    TSpinEdit *dist;
    TLabel *Label35;
    TLabel *Label36;
    TEdit *dir_pref;
    TLabel *Label37;
    TEdit *dir_post;
    TTabSheet *TabSheet4;
    TMemo *exts;
    TTabSheet *TabSheet5;
    TMemo *pacs;
    TLabel *Label76;
    TSpinEdit *topshift;
    TCheckBox *Autocomplete;
    TFontDialog *FontDialog1;
    TTabSheet *TabSheet7;
    TButton *Button2;
    TButton *Button4;
    TButton *Button8;
    TButton *Button9;
    TButton *Button10;
    TButton *Button11;
    TButton *Button12;
    TButton *Button13;
    TButton *Button14;
    TButton *Button15;
    TButton *Button16;
    TButton *Button17;
    TButton *Button18;
    TButton *Button19;
    TButton *Button20;
    TLabel *Label77;
    TEdit *dirstr;
    TCheckBox *extls;
    TGroupBox *GroupBox1;
    TButton *Button1;
    TButton *Button5;
    TButton *Button6;
    TButton *Button7;
    TButton *Button3;
    TButton *Button21;
    TLabel *Label78;
    TEdit *extviewer;
    TLabel *Label79;
    TTabSheet *TabSheet8;
    TStringGrid *BGrid1;
    TButton *Change;
    TColorDialog *ColorDialog1;
    TLabel *Label38;
    TComboBox *iconset;
    TTabSheet *TabSheet3;
    TLabel *Label25;
    TLabel *Label26;
    TSpinEdit *viewerheight;
    TSpinEdit *viewerwidth;
    TTabSheet *TabSheet6;
    TMemo *cr_pacs;
    TLabel *ver_warning;
    void __fastcall CloseClick(TObject *Sender);
    void __fastcall SaveClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall SaveKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall CloseKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall execpathKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall packageprefixKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall tmppathKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall execcompareKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall exteditorKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dateformatKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall showhiddenfilesKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ignorecaseKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall humanreadKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall colwhat1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall colwhat2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall colwhat3KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall colwhat4KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall colwhat5KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dir_prefKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall dir_postKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall hotdir1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall hotdir2KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall hotdir3KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall hotdir4KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall hotdir5KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall extsKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall pacsKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall AutocompleteKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Button1Click(TObject *Sender);
    void __fastcall Button3Click(TObject *Sender);
    void __fastcall Button6Click(TObject *Sender);
    void __fastcall Button5Click(TObject *Sender);
    void __fastcall Button7Click(TObject *Sender);
    void __fastcall Button2Click(TObject *Sender);
    void __fastcall Button4Click(TObject *Sender);
    void __fastcall Button8Click(TObject *Sender);
    void __fastcall Button9Click(TObject *Sender);
    void __fastcall Button10Click(TObject *Sender);
    void __fastcall Button11Click(TObject *Sender);
    void __fastcall Button12Click(TObject *Sender);
    void __fastcall Button13Click(TObject *Sender);
    void __fastcall Button14Click(TObject *Sender);
    void __fastcall Button15Click(TObject *Sender);
    void __fastcall Button16Click(TObject *Sender);
    void __fastcall Button17Click(TObject *Sender);
    void __fastcall Button18Click(TObject *Sender);
    void __fastcall Button19Click(TObject *Sender);
    void __fastcall Button20Click(TObject *Sender);
    void __fastcall dirstrKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall extlsKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Button21Click(TObject *Sender);
    void __fastcall extviewerKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall BGrid1DrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall ChangeClick(TObject *Sender);
    void __fastcall BGrid1KeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall ChangeKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall BGrid1DblClick(TObject *Sender);
        void __fastcall iconsetChange(TObject *Sender);
private:	// User declarations
    MySC *scs;
    int scn;
    int SaveFile();
    void RefreshSC();
    void WriteSC();
    int CallKeyDown(TObject *Sender, WORD &Key,TShiftState Shift);
    int CallKeyDown2(TObject *Sender, WORD &Key,TShiftState Shift);

public:		// User declarations
    AnsiString home;
    __fastcall TConfigForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TConfigForm *ConfigForm;
//---------------------------------------------------------------------------
#endif
