/****************************************************************
*                                                               *
*    Name: MultiRenameTool.h                                    *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*       This file describe things that need for rename multiple *
*       files. The dialog and algorythms                        *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MultiRenameH
#define MultiRenameH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <QControls.hpp>
#include <QStdCtrls.hpp>
#include <QForms.hpp>
#include <QGrids.hpp>
#include <QComCtrls.hpp>
//---------------------------------------------------------------------------
class CFile
{
public:
    AnsiString name;
    AnsiString path;
    AnsiString size;
    int date;

};

class TMultiRenameTool : public TForm
{
__published:	// IDE-managed Components
    TButton *Ok;
    TButton *Cancel;
    TEdit *NameFormat;
    TStringGrid *NewNames;
    TSpinEdit *Start;
    TSpinEdit *Step;
    TLabel *Starthere1;
    TLabel *Step1;
    TLabel *Label1;
    TLabel *Label2;
    TLabel *Label3;
    TLabel *Label4;
    TLabel *Label5;
    TSpinEdit *Counter_width;
    TLabel *Label6;
    TLabel *Label7;
    TLabel *Label8;
    TLabel *Label9;
    TLabel *Label10;
    TLabel *Label11;
    TLabel *Label12;
    TLabel *Label13;
    TLabel *Label14;
    TLabel *Label15;
    TLabel *Label16;
    TLabel *Label17;
    TLabel *Label18;
    TLabel *Label19;
    TLabel *Label20;
    TLabel *Label21;
    void __fastcall FormShow(TObject *Sender);
    void __fastcall CancelClick(TObject *Sender);
    void __fastcall NewNamesDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall OkClick(TObject *Sender);
    void __fastcall Label2Click(TObject *Sender);
    void __fastcall Label3Click(TObject *Sender);
    void __fastcall Label6Click(TObject *Sender);
    void __fastcall Label4Click(TObject *Sender);
    void __fastcall NameFormatKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
    void __fastcall Counter_widthChanged(TObject *Sender, int NewValue);
    void __fastcall StartChanged(TObject *Sender, int NewValue);
    void __fastcall StepChanged(TObject *Sender, int NewValue);
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall Label7Click(TObject *Sender);
    void __fastcall Label8Click(TObject *Sender);
    void __fastcall Label9Click(TObject *Sender);
    void __fastcall Label10Click(TObject *Sender);
    void __fastcall Label11Click(TObject *Sender);
    void __fastcall Label12Click(TObject *Sender);
    void __fastcall Label13Click(TObject *Sender);
    void __fastcall Label14Click(TObject *Sender);
    void __fastcall Label15Click(TObject *Sender);
    void __fastcall Label16Click(TObject *Sender);
    void __fastcall Label17Click(TObject *Sender);
    void __fastcall Label18Click(TObject *Sender);
    void __fastcall Label19Click(TObject *Sender);
    void __fastcall Label20Click(TObject *Sender);
    void __fastcall Label21Click(TObject *Sender);
private:	// User declarations
    void RefreshNewNames();
public:		// User declarations
    int num;
    int status;
    CFile *onames;
    CFile *nnames;
    static AnsiString GetNewName(AnsiString path,AnsiString oldname,AnsiString mask,int counter,int counter_width,int time);
    static AnsiString Interpret(AnsiString path,AnsiString oldname,AnsiString mask,int counter,int counter_width,int time,int &i);
    static int mp3id(AnsiString filename,AnsiString &ptitle,AnsiString &partist,AnsiString &palbum,AnsiString &pyear,AnsiString &pother);
    __fastcall TMultiRenameTool(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMultiRenameTool *MultiRenameTool;
//---------------------------------------------------------------------------
#endif
