/****************************************************************
*                                                               *
*    Name: MyDirent.h                                           *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the header file of the CMyDirent class. This   *
*        will handle the listing a directory content.           *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#ifndef MyDirentH
#define MyDirentH

#include <sys/types.h>
#include <dirent.h>
#include <QTypes.hpp>
//---------------------------------------------------------------------------
class CMyDirent /*: public TThread*/
{
private:
    AnsiString location;
    AnsiString prevlocation;
    int count;

    DIR *dir;
    struct dirent *ent;

public:
    struct sfilelist {
        int attr;
        int uid;
        int gid;
        __int64 size;
        int date;
        AnsiString mask;
        AnsiString name;
        AnsiString link;
    } *filelist;

    CMyDirent ();
    bool SetLocation(AnsiString newpath);
    AnsiString Location() { return location; }
    int Count() {return count;}
};
#endif
