/****************************************************************
*                                                               *
*    Name: Progress.cpp                                         *
*                                                               *
*    Creator: Balazs Tuska                                      *
*                                                               *
*    Description:                                               *
*        This is the CPP file of progressform. This show a      *
*        form, if a procedure take a long time, like copy,      *
*        delete or find a file etc.                             *
*                                                               *
****************************************************************/
//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "Progress.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"
TProgressForm *ProgressForm;
//---------------------------------------------------------------------------
__fastcall TProgressForm::TProgressForm(TComponent* Owner)
    : TForm(Owner)
{
    dirent=new CMyDirent();
}
//---------------------------------------------------------------------------
void __fastcall TProgressForm::yesbClick(TObject *Sender)
{
    hangon=false;
    cancel=false;
    button=mbYes;
}
//---------------------------------------------------------------------------

void __fastcall TProgressForm::nobClick(TObject *Sender)
{
    hangon=false;
    button=mbNo;
}
//---------------------------------------------------------------------------

void __fastcall TProgressForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    cancel=false;
}
//---------------------------------------------------------------------------

void __fastcall TProgressForm::CancelClick(TObject *Sender)
{
    if( 1==TForm1::MessageDlg_my("Do you really want to cancel the operation?","Cancel Operation","Yes","No") )
       cancel=true;
}
//---------------------------------------------------------------------------

void __fastcall TProgressForm::FormShow(TObject *Sender)
{
    Font->Height=13;
    cancel=false;
}
//---------------------------------------------------------------------------

void __fastcall TProgressForm::CancelKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
// close: esc, F3, F10
    if( Key==4096 || Key==4146 || Key==4153 ) {
        if( mbYes==MessageDlg("Do you really want to cancel the operation?",mtWarning,mbYesNo,0) )
           cancel=true;
    }
}
//---------------------------------------------------------------------------


void __fastcall TProgressForm::FormCreate(TObject *Sender)
{
//    SetFocus();    
}
//---------------------------------------------------------------------------

